!function (w, d) {
  "use strict";
  var BG_COLOR = '#1F1F2A';
  var FONT_COLOR = '#8C9AB4';
  var SUB_TITLE_COLOR = '#474C59';

  var wangyiyunPolyfill = {
    init: function () {
      this.wangyiPlay();
    },

    wangyiPlay: function () {

      d.getElementsByClassName('u-footer')[0].style.display = 'none';

      d.getElementsByClassName('m-song-scomt')[0].style.display = 'none';
    }
  };

  var wxPolyfill = {
    init: function () {
      this.wxNormalFix();
      if (typeof IS_NIGHT_MODE !== 'undefined' && IS_NIGHT_MODE === true) {
        this.wxNightMode();
      }
    },
    wxNightModeColor: function (styleAttr) {
      if (!styleAttr) return styleAttr;
      return styleAttr
        .replace(/background-color\s*:[^;]+;/gi, '')
        .replace(/color\s*:[^;]+;/gi, '');
    },
    addLineStyle: function (oldStyles, key, value) {
      var newStyles = ';' + key + ':' + value + ';';
      if (!oldStyles) {
        return newStyles;
      } else {
        return oldStyles + newStyles;
      }
    },
    wxNightMode: function () {
      var allNodes = d.getElementsByTagName("*");
      for (var i = 0, max = allNodes.length; i < max; i++) {
        var curNode = allNodes[i];
        var oldStyles = curNode.getAttribute("style");
        var newStyles = this.wxNightModeColor(oldStyles);

        /*更改标题颜色*/
        if (/rich_media_title/ig.test(curNode.className)) {
          newStyles = this.addLineStyle(newStyles, 'color', FONT_COLOR);
        }

        /*更改小标题颜色*/
        if (/rich_media_meta/ig.test(curNode.className)) {
          newStyles = this.addLineStyle(newStyles, 'color', SUB_TITLE_COLOR);
          if (/meta_original_tag/ig.test(curNode.className)) {
            /*处理border*/
            newStyles = this.addLineStyle(newStyles, 'border', '1px solid ' + SUB_TITLE_COLOR);
          }
        }

        if (/rich_media_content/ig.test(curNode.className)) {
          newStyles = this.addLineStyle(newStyles, 'color', FONT_COLOR);
        }

        if (/rich_media_area_primary/ig.test(curNode.className) || curNode.tagName.toLowerCase() === 'body' || curNode.tagName.toLowerCase() === 'html') {
          newStyles = this.addLineStyle(newStyles, 'background-color', BG_COLOR);
        }

        if (curNode.tagName.toLowerCase() === 'img') {
          newStyles = this.addLineStyle(newStyles, 'opacity', '0.5');
        }

        if (newStyles !== oldStyles) {
          curNode.setAttribute('style', newStyles);
        }
      }
    },
    invokeNative: function (action, params) {
      var iframe = d.createElement('iframe');
      iframe.style.display = 'none';
      var urlString = 'zuiyou://' + action;
      if (params) {
        var paramsString = '';
        var first = true;
        for (var key in params) {
          if (first === false) {
            paramsString += '&';
          }
          first = false;
          paramsString += key + '=' + params[key];
        }
        urlString += '?' + paramsString;
      }
      iframe.src = urlString;
      d.body.appendChild(iframe);
      setTimeout(function () {
        iframe.remove();
      }, 100);
    },
    wxNormalFix: function () {
      /*去掉a标签链接*/
      var allLinks = d.getElementsByTagName('a');
      for (var k = 0, maxK = allLinks.length; k < maxK; k++) {
        allLinks[k].removeAttribute('href');
      }

      var obj1 = d.getElementById('js_view_source');
      if (obj1) {
        obj1.parentNode.removeChild(obj1);
      }

      var obj2 = d.getElementById('js_report_article');
      if (obj2) {
        obj2.parentNode.removeChild(obj2);
      }

      var obj3 = d.getElementById('js_profile_arrow_wrp');
      if (obj3) {
        obj3.parentNode.removeChild(obj3);
      }

      var obj4 = d.getElementById('js_profile_qrcode');
      if (obj4) {
        obj4.parentNode.removeChild(obj4);
      }

      /* 通知完成 安卓播放视频 */
      var allIframes = d.getElementsByTagName('iframe');
      var videoFrameCount = 0;
      for (var i = 0, max = allIframes.length; i < max; ++i) {
        if (allIframes[i].className === "video_iframe") {
          ++videoFrameCount;
        }
      }
      this.invokeNative("complete", {"total": videoFrameCount + 1});
    }
  };

  try {
    switch (w.location.hostname) {
      case 'music.163.com':
        wangyiyunPolyfill.init();
        break;
      case 'mp.weixin.qq.com':
        wxPolyfill.init();
        break;
      default:
        break;
    }
  } catch (e) {
    console.log(e)
  }
}(window, document);
